
<?

	$certFile = "./openssl/crypto/certs/certClient.p12";
	$keyFile ="./openssl/crypto/certs/keyClient.key";
	$passFile ="./config/password.txt";
	$certReady = false;

	if (get_magic_quotes_gpc()) {
		$emailAddress = stripslashes($_REQUEST['dn']['emailAddress']);
		$secret = stripslashes($_REQUEST['secret']);
		$SPKAC = stripslashes($_REQUEST['SPKAC']);
		$reqEntry = stripslashes($_REQUEST['reqEntry']);
		$clave = stripslashes($_REQUEST['clave']);
		while (list($key, $val) = each($_REQUEST['dn'])) {
			$dn[$key] = stripslashes($val);
		}

	}
	else {

		$emailAddress = &$_REQUEST['dn']['emailAddress'];
		$secret = &$_REQUEST['secret'];
		$reqEntry = &$_REQUEST['reqEntry'];
		$SPKAC = &$_REQUEST['SPKAC'];
		$dn = &$_REQUEST['dn'];
		$clave = &$_REQUEST['clave'];


	}
	if (!$_REQUEST['clave']) {
		printHeader("Error");
		print "<h1>Error</h1>\n";
		print "Debe introducir una contrasea.<br/>\n";
		print "--&gt; <a href=\"index.php?area=apply\">Intntelo de nuevo</a><br/>\n";
		printFooter();
	}

	elseif (!$emailAddress) {

		printHeader("Direccin de correo electrnico no encontrada");
		print "<h1>Direccin de correo electrnico no encontrada</h1>";
		print "Debe escribir su direccin de correo electrnico.<br/>\n";
		print "--&gt; <a href=\"index.php?area=apply\">Intntelo de nuevo</a><br/>\n";


		printFooter();
	}

	else {

		if($fp = fopen($passFile,'w')){
			fputs($fp, $clave);
			fclose($fp);
		}
		
		$cwd = getcwd();
		@mkdir("$cwd/openssl/crypto/certs", 0700);

		if ($fp=fopen("openssl/crypto/cacerts/cacert.pem","r")) {
			$certData=fread($fp,8192);
			fclose($fp);
		}
		else {
			printHeader("Error");
			print "<h1>Error</h1>";
			print "Error leyendo mi certificado, compruebe los permisos<br/>\n";
			printFooter();
			return;
		}
		$caCert = openssl_x509_read($certData);
		checkError($caCert);

		if ($fp=fopen("openssl/crypto/keys/cakey.pem","r")) 			{	
			$privKey=fread($fp,8192);
			fclose($fp);		
		}
		else {
			printHeader("Error");
			print "<h1>Error</h1>";
			print "Error leyendo mi clave, compruebe los permisos<br/>\n";
			printFooter();
			return;
		}

		$caKey = openssl_get_privatekey($privKey,$config['passPhrase']);
		checkError($caKey);

		/**/
	
		// Create the keypair
		$res=openssl_pkey_new();

		// Get private key
		openssl_pkey_export($res, $privKeyClient);

		// Get public key
		$pubKeyClient=openssl_pkey_get_details($res);
		$pubKeyClient=$pubKeyClient["key"];
	
		openssl_pkey_export($privKeyClient, $pkeyout, $_REQUEST['clave']);
		
		$csrCert = openssl_csr_new($_REQUEST['dn'], $privKeyClient);
		
		openssl_csr_export_to_file($csrCert,'openssl/crypto/requests/solicitudcert.csr',FALSE);
		$signedCert = openssl_csr_sign($csrCert, $caCert, $caKey, 365*2, $config, getSerial());

		//$certout tiene formato .p12
		openssl_pkcs12_export($signedCert,$certout,$privKeyClient,$_REQUEST['clave']);
		/**/
		checkError($signedCert);
	
		/**/
		if ($fp = fopen($certFile, 'w')) {
			fputs($fp, $certout);
			fclose($fp);
		}
		
		if ($fp = fopen($keyFile, 'w')) {
			fputs($fp, $pkeyout);
			fclose($fp);
		}

		/**/
		$certReady = 'xenroll';
	}


	if ($certReady) {
		
		if ($certReady == 'xenroll') {

			$cert = addslashes(preg_replace('/^.*-{5}([^ ]+)-{5}.*$/', '$1', preg_replace('/\n/', '', $myCert)));
			$inhead = <<<HTML
<!-- Use the Microsoft ActiveX control to generate the certificate -->
<object 
	classid="clsid:127698e4-e730-4e5c-a2b1-21490a70c8a1" 	codebase="/certcontrol/xenroll.dll" 
	id="certHelper">
</object>
<script type="text/javascript">
<!--

//function InstallCert(cert)
//{
//    if (!cert) {
//		alert("No certificate found");
//		return false;
//    } 
//
//	try {
//	    certHelper.acceptPKCS7(cert);
//	}
//	catch (e) {
//		alert ("Error accepting certificate");
//		return false;
//	}
//}

var cert = "$cert";
InstallCert(cert);

//-->
</script>
HTML;
		}
		printHeader("Certificado de cliente instalado", $inhead);
?>

<h1>Instalacin del Certificado Cliente</h1>

<p>
<?

		if ($certReady == 'spkac') {
			print "Su certificado de cliente est preparado. Por favor <a href=\"index.php?area=apply&stage=fetchSpkac&id=$secret\">Instlelo ahora</a>; Nota: su navegador est instalando el certificado.";
		}

		else {
			/**/
			print "Su certificado de cliente est preparado. Por favor <a href=\"./openssl/crypto/certs/certClient.p12\">Instlelo ahora</a>; Nota: su navegador est instalando el certificado.";
			/**/
		}

?>
<br/>
Para que su certificado personal tenga validez deber <a href="index.php?area=main&stage=trust"> instalar esta AC como un servidor de autoridad certificadora de confianza </a>
</p>

<?
		printFooter();
}
?>