<?

$certFile = "./openssl/crypto/cacerts/cacert.pem";
$keyFile = "./openssl/crypto/keys/cakey.pem";

$configFile = "./config/configuration.php";

include_once($configFile);

$passPhrase = $config['passPhrase'];

if ($_REQUEST['pass'] != $passPhrase) {
	/*print "<h1>Renewing CA certificate</h1><p><b>Passphrase incorrect</b><br/>You did not enter the correct passphrase";*/
	print "<h1>Renovar certificado de AC-UPCT</h1><p><b>Contrasea incorrecta</b><br/>No introdujo la contrasea correctamente";
	return;
}

?>
<!--<h1>Signing certificate request</h1>-->
<h1>Firmando solicitud de certificado</h1>

<!--<p>
We will sign the supplied certificate request with the CA's keys. The signed certificate will be returned.
</p>-->
<p>
Vamos a firmar la solicitud del certificado suministrado con las claves de la AC. Se le devolver el certificado firmado.
</p>

<!--<p>
Now signing certificate... Please wait...
</p>-->
<p>
Firmando el certificado... Por favor espere...
</p>
<?
// Ok, lets go. Time to create us a CA Cert.
// Vamos a crear nuestro certificado de la AC-UPCT.
$errorCount = 0;

/*print "<b>Loading CA key...</b><br/>";*/
print "<b>Cargando clave de la AC...</b><br/>";
$fp = fopen($keyFile, "r") or $errorCount++;
$myKey = fread($fp, filesize($keyFile)) or $errorCount++;
fclose($fp) or $errorCount++;
if ($errorCount) {
	/*print "FATAL: an error occured in the script. Possibly due to inadequate file permissions.";*/
	print "ERROR FATAL: ha ocurrido un error en el script. Posiblemente debido a permisos inadecuados de los archivos.";
	exit();
}
/*print "Done<br/><br/>\n";*/
print "Hecho<br/><br/>\n";

/*print "<b>Decoding CA key...</b><br/>";*/
print "<b>Decodificando clave de la AC...</b><br/>";
$privkey = openssl_pkey_get_private($myKey, $passPhrase);
checkError($privkey);
/*print "Done<br/><br/>\n";*/
print "Hecho<br/><br/>\n";

/*print "<b>Loading CA cert...</b><br/>";*/
print "<b>Cargando certificado de la AC...</b><br/>";
if ($fp = fopen($certFile, "r")) {
	$myCert = fread($fp, filesize($certFile)) or $errorCount++;
	fclose($fp) or $errorCount++;
}
else $errorCount++;

if ($errorCount) {
	/*print "FATAL: an error occured in the script. Possibly due to inadequate file permissions.";*/
	print "ERROR FATAL: ha ocurrido un error en el script. Posiblemente debido a permisos inadecuados de los archivos.";
	exit();
}
/*print "Done<br/><br/>\n";*/
print "Hecho<br/><br/>\n";

/*print "<b>Signing CSR...</b><br/>";*/
print "<b>Firmando CSR...</b><br/>";
$scert = openssl_csr_sign($_REQUEST['request'], $myCert, $privkey, 365);
checkError($scert);
/*print "Done<br/><br/>\n";*/
print "Hecho<br/><br/>\n";

/*print "<b>Exporting X509 Certificate...</b><br/>";*/
print "<b>Exportando certificado X509...</b><br/>";
checkError(openssl_x509_export($scert, $theirCert));
/*print "Done<br/><br/>\n";*/
print "Hecho<br/><br/>\n";

/*print "<b>Your certificate:</b>\n<pre>$theirCert</pre>\n";*/
print "<b>Su certificado:</b>\n<pre>$theirCert</pre>\n";

?>
<!--<h1>Successfully signed certificate request with CA key.</h1>-->
<h1>Firma del certificado AC con la clave AC de manera satisfactoria.</h1>

