<h1>Bienvenido a la Autoridad Certificadora de la UPCT</h1>

<p>
Esta autoridad certificadora debe ser creada para la UPCT por el personal administrativo (rellenando el formulario que usted ver a continuacin) para emitir certificados a sus empleados, sin la necesidad de contactar con una autoridad de mayor escala.
</p>

<p>
Esta autoridad va a identificar al usuario en cuestin mediante la autenticacin en el Punto de Acceso nico (PAU) de la UPCT, por tanto si no dispone de usuario de esta entidad no podr conseguir su certificado.
</p>

<p>
Los certificados emitidos pueden ser utilizados para probar la identidad de la persona, y permitir a dichos propietarios (basndonos en la confianza en el emisor) el acceso a diversas reas corporativas o de administracin.
</p>

<h1>Primer uso de este software (Personal Administrativo)</h1>

<p>
Si es la primera vez que usa este software debe configurar los datos de la organizacin (en este caso UPCT), para ello deber rellenar el siguiente formulario que contiene la informacin bsica para crear el certificado de la entidad emisora (Autoridad Certificadora UPCT).
</p>

<form method="post" action="index.php">
<input type="hidden" name="stage" value="create">
	<fieldset>
		<legend>AC Datos del Certificado</legend>
		<p>
		Debe escribir la informacin sobre su organizacin (en este caso la UPCT) y el departamento que se encarga de la gestin de la entidad de certificacin.
		</p>
		
		<p>
		Esta informacin se mostrar en el interior de cada certificado emitido por este software.
		</p>

		<table>
		<colgroup><col width="180px"></colgroup>
		<tr><th>Nombre de la compaa</th><td><input type="text" name="dn[commonName]" value="Autoridad de Certificacion UPCT" size="40"></td></tr>
		<tr><th>Direccin de correo electrnico</th><td><input type="text" name="dn[emailAddress]" value="cert@upct.es" size="40"></td></tr>
		<tr><th>Nombre de la organizacin</th><td><input type="text" name="dn[organizationName]" value="UPCT" size="40"></td></tr>
		<tr><th>Nombre del departamento</th><td><input type="text" name="dn[organizationalUnitName]" value="Certificacion" size="40"></td></tr>
		</table>
		
		<p>
		A continuacin deber indicar la ubicacin fsica de la entidad que est creando.
		</p>

		<table>
		<colgroup><col width="180px"></colgroup>
		<tr><th>Ciudad</th><td><input type="text" name="dn[localityName]" value="Cartagena" size="25"></td></tr>
		<tr><th>Provincia</th><td><input type="text" name="dn[stateOrProvinceName]" value="Murcia" size="25"></td></tr>
		<tr><th>Pas</th><td><input type="text" name="dn[countryName]" value="ES" size="25"></td></tr> 
		</table>

		<p>
		A continuacin deber introducir una contrasea, la cual ser usada para el rea de administracin y para cifrar la clave privada de esta Autoridad Certificadora.
		</p>

		<p>
		Esta clave debe ser relativamente larga. Se almacenar en la unidad de texto plano porque tenemos q ser capaces de firmar conciertos bajo demanda.
		</p>

		<table>
		<colgroup><col width="180px"></colgroup>
		<tr><th>Contrasea</th><td><input type="password" name="passPhrase" value="Campus Mare Nostrum" size="60"></td></tr>
		<tr><td colspan=2 style="text-align: right;"><input type="submit" value="Crear AC"></td></tr>
		</table>
	</fieldset>
</form>
